#define DEVICE 0 // GPU ID

// Spatial size - should be 2^n
#define NY 512
#define NX 512
#define NZ 512

#define HH 0.666f // SPATIAL STEP
#define DT 0.1f   // TIME STEP

#define R0 (128.0f) // IN PIXELS
#define D0 (1.0f)  // IN PIXELS

#define NSTEPS 1000000 // TOTAL TIME STEPS
#define MSTEPS 1000  // FREQUENCY OF MEASURING THE ENERGY DENSITY
#define SSTEPS 10000  // FREQUENCY OF SAVING THE DATA

#define PSI (-0.25f)  // AVERAGE DENSITY
#define GAMMA (3.0f*PSI*PSI*1.05f) // TEMPERATURE

#define RAMP (0.01f*PSI) // INITIAL RANDOM AMPLITUDE
#define BCCA (-10.0f*PSI*0.0f)

#define EPS (GAMMA-3.0f*PSI*PSI)
#define LINOP(K2) ((1.0f-K2)*(1.0f-K2)-EPS) // LINEAR OPERATOR IN THE ENERGY
#define NLFUNC(Y) (3.0f*PSI*Y*Y+Y*Y*Y) // NONLINEAR FUNCTION IN THE DYNAMICAL EQUATION
#define MOBFNC(R,RC,DD) (0.5f*(1.0f-tanhf((R-HH*RC)/(HH*DD))))

#define NLENRG(Y) (PSI*Y*Y*Y+Y*Y*Y*Y/4.0f)  // NONLINEAR PART OF THE ENERGY

